﻿'''''''''''''C:\Program Files\Microsoft SDKs\Kinect\Developer Toolkit v1.5.1\Redist\x86フォルダ内のFaceTrackData.dllとFaceTrackLib.dllをbin\Debugフォルダ内にコピーしておく
Option Strict On
Imports Microsoft.Kinect
Imports Microsoft.Kinect.Toolkit

Class MainWindow
    Dim Bgr32BytesPerPixel As Integer = CInt((PixelFormats.Bgr32.BitsPerPixel) / 8)
    Dim sensorChooser As New KinectSensorChooser()
    Dim Kinect As KinectSensor

    Public Sub MainWindow_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        Dim faceTrackingViewerBinding = New Binding("Kinect") With {.Source = sensorChooser}
        FaceTrackingViewer1.SetBinding(FaceTrackingViewer.KinectProperty, faceTrackingViewerBinding)
        AddHandler sensorChooser.KinectChanged, AddressOf SensorChooserOnKinectChanged
        sensorChooser.Start()
    End Sub

    Private Sub SensorChooserOnKinectChanged(sender As Object, e As KinectChangedEventArgs)
        Kinect = e.NewSensor

        If Kinect Is Nothing = False Then
            Kinect.ColorStream.Enable(ColorImageFormat.RgbResolution640x480Fps30)
            Kinect.DepthStream.Enable(DepthImageFormat.Resolution320x240Fps30)
            Kinect.DepthStream.Range = DepthRange.Near
            Kinect.SkeletonStream.EnableTrackingInNearRange = True
            Kinect.SkeletonStream.TrackingMode = SkeletonTrackingMode.Seated
            Kinect.SkeletonStream.Enable()

            AddHandler Kinect.AllFramesReady, AddressOf KinectSensorOnAllFramesReady
        End If
    End Sub


    Private Sub KinectSensorOnAllFramesReady(sender As Object, e As AllFramesReadyEventArgs)
        Using colorImageFrame = e.OpenColorImageFrame()
            Using depthImageFrame = e.OpenDepthImageFrame
                Dim kinect As KinectSensor = TryCast(sender, KinectSensor)
                If kinect Is Nothing = True Then
                    Return
                End If

                If colorImageFrame Is Nothing = True Then
                    Return
                End If

                If (colorImageFrame IsNot Nothing) AndAlso (depthImageFrame IsNot Nothing) Then
                    Dim getBackgroundMask As Byte() = BackgroundMask(kinect, colorImageFrame, depthImageFrame)
                    colorImage.Source = BitmapSource.Create(colorImageFrame.Width, colorImageFrame.Height, 96, 96, PixelFormats.Bgr32, Nothing, getBackgroundMask, colorImageFrame.Width * colorImageFrame.BytesPerPixel)
                End If
            End Using
        End Using
    End Sub


    Private Sub MainWindow_Closing(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles Me.Closing
        sensorChooser.Stop()
        FaceTrackingViewer1.Dispose()
    End Sub

    Private Function BackgroundMask(kinect As KinectSensor, colorFrame As ColorImageFrame, depthFrame As DepthImageFrame) As Byte()
        Dim colorStream As ColorImageStream = kinect.ColorStream
       
        Dim colorPixel As Byte() = New Byte(colorFrame.PixelDataLength - 1) {}
        colorFrame.CopyPixelDataTo(colorPixel)

        Dim outputColor As Byte() = New Byte(colorPixel.Length - 1) {}
        Dim i As Integer = 0

        While i < outputColor.Length
            outputColor(i) = 0
            outputColor(i + 1) = 0
            outputColor(i + 2) = 0
            i = i + Bgr32BytesPerPixel
        End While
        Return outputColor
    End Function
End Class
